import { inject, Injectable } from '@angular/core';
import { HermesClientService } from '../../hermes-client.service';
import { map, of } from 'rxjs';
import RedeemableAction from '../models/redeemable_action';

@Injectable({
  providedIn: 'root'
})
export class RedeemableActionService {
  private client = inject(HermesClientService);
  private data: RedeemableAction[] = []
  loaded = false;


  fetch() {
    if (this.loaded) {
      return of(this.data);
    }

    const $ = this.client.filterByRequestType('get_redeemable_actions')!.pipe(map(d => d.data));
    $.subscribe(d => {
      this.data = d;
      this.loaded = true;
    });
    this.client.fetchRedeemableActions();
    return $;
  }
}
