import { inject, Injectable } from '@angular/core';
import Redemption from '../models/redemption';
import { HermesClientService } from '../../hermes-client.service';
import { map, Observable, of } from 'rxjs';

@Injectable({
  providedIn: 'root'
})
export class RedemptionService {
  private client = inject(HermesClientService);
  private data: Redemption[] = []
  create$: Observable<any> | undefined;
  fetch$: Observable<any> | undefined;
  update$: Observable<any> | undefined;
  delete$: Observable<any> | undefined;
  loaded = false;

  constructor() {
    this.create$ = this.client.filterByRequestType('create_redemption');
    this.update$ = this.client.filterByRequestType('update_redemption');
    this.delete$ = this.client.filterByRequestType('delete_redemption');
  }


  fetch() {
    if (this.loaded) {
      return of(this.data);
    }

    const $ = this.client.first(d => d.d.request.type == 'get_redemptions')!.pipe(map(d => d.d.data));
    $.subscribe(d => {
      this.data = d;
      this.loaded = true;
    });
    this.client.fetchRedemptions();
    return $;
  }
}
